package ru.myitschool.work.data.source;

import java.util.List;

import retrofit2.Call;
import retrofit2.http.Body;
import retrofit2.http.GET;
import retrofit2.http.Path;
import ru.myitschool.work.data.dto.HistoryDto;
import ru.myitschool.work.data.dto.PassingDto;
import ru.myitschool.work.data.dto.UserDto;


public interface UserApi {
    @GET("api/user")
    Call<List<UserDto>> getAllUsers();
    @GET("api/{username}/info")
    Call<UserDto> getUserByUsername(@Path("username") String Username);
    @GET("api/{username}/auth")
    Call<Void> isExistUser(@Path("username") String username);
    @GET("api/login")
    Call<Void> login();
    @GET("api/{username}/passing")
    Call<List<HistoryDto>> getAllUserHistory(@Path("username") String username);
    @GET("api/{username}/passing/new")
    Call<Void> postNewHistory(@Body PassingDto dto, @Path("username") String username);
  /*  @GET("api/history/{id}")
    Call<HistoryDto> getHistoryById(@Path("id") Integer id);
*/
}
