package ru.myitschool.work.ui;

import android.os.Bundle;
import android.util.Log;
import android.view.View;
import android.widget.Toast;

import androidx.appcompat.app.AppCompatActivity;
import androidx.lifecycle.LiveData;
import androidx.lifecycle.ViewModelProvider;
import androidx.navigation.NavController;
import androidx.navigation.Navigation;
import androidx.navigation.fragment.NavHostFragment;

import ru.myitschool.work.R;
import ru.myitschool.work.databinding.ActivityRootBinding;
import ru.myitschool.work.databinding.FragmentProfileBinding;
import ru.myitschool.work.domain.entities.UserEntity;
import ru.myitschool.work.ui.profile.ProfileViewModel;
import ru.myitschool.work.ui.qr.scan.QrScanDestination;
import ru.myitschool.work.utils.PreferenceManager;

public class RootActivity extends AppCompatActivity {
    private ActivityRootBinding binding;


    @Override
    protected void onCreate(Bundle savedInstanceState) {
        super.onCreate(savedInstanceState);

        binding = ActivityRootBinding.inflate(getLayoutInflater());
        setContentView(binding.getRoot());
        binding.navView.setOnItemSelectedListener(item -> {
            switch (item.getItemId()) {
                case R.id.history:
                    onClickNavHistory();
                    break;
                case R.id.profile:
                    onClickNavProfile();
                    break;
            }
            return true;
        });

        binding.qrScan.setOnClickListener(view -> {
            onClickScan();
        });


        /*getSupportFragmentManager().setFragmentResultListener(QrScanDestination.REQUEST_KEY, this, (requestKey, result) -> {
            String res = "";
            if (result.get(requestKey) != null) {
                res = result.get(requestKey).toString();
            }
            //Toast.makeText(getContext(), res, Toast.LENGTH_LONG).show();


            Toast.makeText(this, "EEEEEEEEEEEEEEEEEEEE", Toast.LENGTH_SHORT).show();

            //ResultFragment resFragment = ResultFragment.newInstance(res);
            //Navigation.findNavController(view).navigate(R.id.action_informationFragment_to_resultFragment);
            NavHostFragment navHostFragment =
                    (NavHostFragment) getSupportFragmentManager().findFragmentById(R.id.root_fragment);
            NavController navController = navHostFragment.getNavController();
            navController.navigate(R.id.action_informationFragment_to_resultFragment);
            //getFragmentManager().beginTransaction().replace(R.id.nav_host_fragment, resFragment).commit();
        });*/
    }

    private void onClickScan() {
        NavHostFragment navHostFragment =
                (NavHostFragment) getSupportFragmentManager().findFragmentById(R.id.root_fragment);
        NavController navController = navHostFragment.getNavController();
        navController.navigate(R.id.action_informationFragment_to_qrScanFragment);
        //getFragmentManager().beginTransaction().replace(R.id.nav_host_fragment, new QrScanFragment()).commit();
    }

    private void onClickNavHistory() {
        NavHostFragment navHostFragment =
                (NavHostFragment) getSupportFragmentManager().findFragmentById(R.id.root_fragment);
        NavController navController = navHostFragment.getNavController();
        navController.navigate(R.id.action_profileFragment_to_informationFragment);
        //navHostFragment.getChildFragmentManager().getFragments().get(0);
        switch (navController.getCurrentDestination().getId()) {
//            case R.id.historyFragment:
//                navController.navigate(R.id.action_listFragment_to_mapFragment);
//                break;
            case R.id.profileFragment:
                //navController.navigate(R.id.action_profileFragment_to_informationFragment);
                //Navigation.findNavController(view).navigate(R.id.action_loginFragment_to_informationFragment);
                break;
        }
        Log.d("tagigi", navController.getCurrentDestination().getId() + "");
        //Log.d("tagigi", R.id.listFragment + "");
        //.navigate(R.id.action_listFragment_to_mapFragment);
    }

    private void onClickNavProfile() {
        NavHostFragment navHostFragment =
                (NavHostFragment) getSupportFragmentManager().findFragmentById(R.id.root_fragment);
        NavController navController = navHostFragment.getNavController();
        navController.navigate(R.id.action_informationFragment_to_profileFragment);
        //navController.navigate(R.id.action_listFragment_to_profileFragment);
        switch (navController.getCurrentDestination().getId()) {
            case R.id.informationFragment:
//                navController.navigate(R.id.action_informationFragment_to_profileFragment);
                break;
//            case R.id.profileFragment:
//                navController.navigate(R.id.action_mapFragment_to_profileFragment);
//                break;
        }
    }
/*
    @Override
    public boolean onSupportNavigateUp() {
        NavController navController = Navigation.findNavController(this, R.id.nav_host_fragment_content_main);
        return NavigationUI.navigateUp(navController, appBarConfiguration)
                || super.onSupportNavigateUp();
    }*/
}