package ru.myitschool.work.ui.result;

import android.util.Log;

import androidx.annotation.NonNull;
import androidx.annotation.Nullable;
import androidx.lifecycle.LiveData;
import androidx.lifecycle.MutableLiveData;
import androidx.lifecycle.ViewModel;

import ru.myitschool.work.data.UserRepositoryImpl;
import ru.myitschool.work.domain.CreateHistoryUseCase;
import ru.myitschool.work.domain.GetAllUserHistoryUseCase;
import ru.myitschool.work.domain.GetUserByUsernameUseCase;
import ru.myitschool.work.domain.entities.HistoryEntity;
import ru.myitschool.work.domain.entities.UserEntity;
import ru.myitschool.work.domain.sign.IsUserExistUseCase;

public class ResultViewModel extends ViewModel {
    private final MutableLiveData<State> mutableStateLiveData = new MutableLiveData<>();

    public final LiveData<State> stateLiveData = mutableStateLiveData;

    public final GetUserByUsernameUseCase getUserByUsernameUseCase = new GetUserByUsernameUseCase(
            UserRepositoryImpl.getInstance()
    );

    /*public final GetAllUserHistoryUseCase getAllUserHistoryListUseCase = new GetAllUserHistoryUseCase(
            UserRepositoryImpl.getInstance()
    );*/
    private final IsUserExistUseCase isUserExistUseCase = new IsUserExistUseCase(
            UserRepositoryImpl.getInstance()
    );

    private final CreateHistoryUseCase createHistoryUseCase = new CreateHistoryUseCase(
            UserRepositoryImpl.getInstance()
    );

    public void load(@NonNull String username) {
        //mutableStateLiveData.setValue(new State(null, null, true));
        //postUserByUsername(username);
    }

    public void postUserByUsername(String username, String time, String type, String code) {
        final String currentUsername = username;
        final String currentTime = time;
        final String currentType = type;
        final String currentCode = code;
        mutableStateLiveData.setValue(new State(null, false, true));
        if (currentUsername == null || currentUsername.isEmpty()) {
            //mutableErrorLiveData.postValue("Login cannot be null");
            return;
        }
        createHistoryUseCase.execute(currentUsername, currentTime, currentType, currentCode, status -> {
            if (status.getStatusCode() == 201 && status.getErrors() == null) {
                mutableStateLiveData.setValue(new State(null, true, false));
            } else {
                mutableStateLiveData.setValue(new State(null, false, false));
            }
        });
    }




    public class State {
        @Nullable
        private final String errorMessage;

        @Nullable
        private final boolean sended;

        private final boolean isLoading;

        public State(@Nullable String errorMessage, boolean sended, boolean isLoading) {
            this.errorMessage = errorMessage;
            this.sended = sended;
            this.isLoading = isLoading;
        }

        @Nullable
        public String getErrorMessage() {
            return errorMessage;
        }

        @Nullable
        public boolean getSended() {
            return sended;
        }

        public boolean isLoading() {
            return isLoading;
        }
    }
}
